.macro _putstr
	rcall	putstr
		.db @0, 0
.endmacro

.macro _putc
	ldi	temp, @0
	rcall	putc
.endmacro

;--------------------

putstr:
	;send string to UART
	;  PARAMS: 0-terminated string
	pop	ZH
	pop	ZL
	lsl	ZL
	rol	ZH
putstr_loop:
	lpm	temp, Z+
	cpi	temp, 0
	breq	putstr_end
	rcall	putc
	rjmp	putstr_loop
putstr_end:
	adiw	ZH:ZL, 1
	lsr	ZH
	ror	ZL
	ijmp ;return

;--------------------

;puthex:
;	;send 8-bit hex value to UART
;	push	temp
;	swap	temp
;	rcall	puthex_sub
;	pop	temp
;puthex_sub:
;	andi	temp, 0x0F
;	ori	temp, '0'
;	cpi	temp, 0x3A
;	brlo	PC+2
;	subi	temp, -7
;	rjmp	putc

;--------------------

putbcd:
	;send packed BCD value to UART (simplified puthex)
	push	temp
	swap	temp
	rcall	putbcd_sub
	pop	temp
putbcd_sub:
	andi	temp, 0x0F
	ori	temp, '0'
	;(fall through to putc)
;--------------------
putc:
	;send char to UART
	sbis	UCSRA, UDRE
	rjmp	putc
	out	UDR, temp
	ret
